endif
endif
RSTRIP:= \
+ export CROSS="$(TARGET_CROSS)"; \
NM="$(TARGET_CROSS)nm" \
STRIP="$(STRIP)" \
- STRIP_KMOD="$(TARGET_CROSS)strip --strip-unneeded -R .comment -R .pdr -R .mdebug.abi32 -R .note.gnu.build-id -R .gnu.attributes -R .reginfo -x" \
+ STRIP_KMOD="$(SCRIPT_DIR)/strip-kmod.sh" \
$(SCRIPT_DIR)/rstrip.sh
endif
# This is free software, licensed under the GNU General Public License v2.
# See /LICENSE for more information.
#
-
-find_modparams() {
- FILE="$1"
- $NM "$FILE" | awk '
-BEGIN {
- FS=" "
-}
-($3 ~ /^__module_parm_/) && ($3 !~ /^__module_parm_desc/) {
- gsub(/__module_parm_/, "", $3)
- printf "-K " $3 " "
-}
-($2 ~ /r/) && ($3 ~ /__param_/) {
- gsub(/__param_/, "", $3)
- printf "-K " $3 " "
-}
-'
-}
-
-
SELF=${0##*/}
[ -z "$STRIP" ] && {
while read F S; do
echo "$SELF: $F:$S"
[ "${S}" = "relocatable" ] && {
- eval "$STRIP_KMOD -w -K '__param*' -K '__mod*' $(find_modparams "$F")$F"
+ eval "$STRIP_KMOD $F"
} || {
b=$(stat -c '%a' $F)
eval "$STRIP $F"
--- /dev/null
+#!/usr/bin/env bash
+[ -n "$CROSS" ] || {
+ echo "The variable CROSS must be set to point to the cross-compiler prefix"
+ exit 1
+}
+
+MODULE="$1"
+
+[ "$#" -ne 1 ] && {
+ echo "Usage: $0 <module>"
+ exit 1
+}
+
+${CROSS}objcopy \
+ --strip-unneeded \
+ -R .comment \
+ -R .pdr \
+ -R .mdebug.abi32 \
+ -R .note.gnu.build-id \
+ -R .gnu.attributes \
+ -R .reginfo \
+ -G __this_module \
+ -x "$MODULE" "$MODULE.tmp"
+
+${CROSS}nm "$MODULE.tmp" | awk '
+BEGIN {
+ n = 0
+}
+
+$3 && $2 ~ /[brtd]/ && $3 !~ /\$LC/ {
+ print "--redefine-sym "$3"=_"n;
+ n = n + 1
+}
+' > "$MODULE.tmp1"
+
+${CROSS}objcopy `cat ${MODULE}.tmp1` ${MODULE}.tmp ${MODULE}.out
+mv "${MODULE}.out" "${MODULE}"
+rm -f "${MODULE}".t*